import os
import re
import ch_scripts as pr1
import subprocess
import math

print 'start'

def findgaps(input, object):
    gaps = []
    for i, j in enumerate(input):
        if j == object:
            gaps.append(i)
    return gaps

def gapsposition (path, phylob, ins):
    phyloblockfile = open(path, 'r')
    ggaps = []
    seqlengths = []
    for line in phyloblockfile:
        if line.startswith('>'):
            gapseq = line.strip().split()[1]
            seqlength = len(gapseq.replace('-',''))
            seqlengths.append(seqlength)
            gaps = findgaps(gapseq, '-')
            ggaps.append(gaps)
    phyloblockfile.close()
    ga = ggaps[0]
    iti = 0
    for g in ggaps:
        iti += 1
        if ga == g:
            ga = g
            mingap = g
            seqlength = seqlengths[iti - 1]
        else:
            if len(g) < len(ga):
                mingap = g
                ga = g
                seqlength = seqlengths[iti-1]
                #print ga
                #print g
                #print 'more then one set of gaps!\n\n\n\n'
            elif 'mingap' not in locals():
                mingap = g
                print 'not in locals'
    startposition = int(phylob[0][4])
    endposition = int(phylob[0][5])
    if endposition > seqlength:
        pass
    for element in range(len(mingap)):
        mingap[element] -= (startposition - 1)
    preprocessedseq = phylob[0][8]
    if phylob[0][9] != 'NAN':
        seqinsert = phylob[0][9].strip().split('_')
        for insert in seqinsert:
            if int(insert) in mingap:
                mingap.remove(int(insert))
            else:
                ins.append(int(insert)+startposition-1)
    if phylob[0][10] != 'NAN':
        gap_seq = phylob[0][10].strip().split('_')
        for integr in gap_seq:
            preprocessedseq = preprocessedseq[:int(integr)] + '-' + preprocessedseq[int(integr):]
    for integr in mingap:
        preprocessedseq = preprocessedseq[:integr] + '-' + preprocessedseq[integr:]
    preprocessedseq = '-'*(startposition-1) + preprocessedseq
    preprocessedseq = preprocessedseq + '-'*(seqlength-endposition)
    return {'preprocessedseq':preprocessedseq, 'insertions':ins}

def getlistofseq(path):
    inp = open(path, 'r')
    output = {}
    for line in inp:
        if line.startswith('>'):
            seqname = line.replace('>','').replace('\n','').replace('\r','').replace('(','').replace(')','')
        elif line.startswith('\r\n'):
            pass
        else:
            sequence = line.replace('\r','').replace('\n','')
            output[seqname] = sequence
    inp.close()
    return output

def seqpreprocess(block, filename, path, block_lengths):
    back = ''
    # pr1.crdir(filename+'_test_1/blocks_output/blocks_for_phylogeny/'+block)
    os.chdir(path + block + '/')
    timebackagain = (path + block + '/').strip().split('/')
    timeback = ''
    for times in range(len(timebackagain) - 1):
        if (timebackagain[times] == '..'):
            pass
        else:
            timeback += '../'
    back += '../../../../'
    wrkfile = open('all_seqanalysis', 'r')
    output = open('all_seq_preprocessed', 'w')
    dbase = filename + '.711genomes.fasta'
    gdatabase = back + filename + '/' + dbase
    wrkdatabase = getlistofseq(gdatabase)
    wrkdatabase_2 = dict(wrkdatabase)
    insertions = []
    insertioninfo = []
    output.writelines('# Preprocessed sequences:\n')
    for line in wrkfile:
        if line.startswith('# Total number of sequences'):
            totnumber = int(line.strip().split('\t')[1])
        elif line.startswith('# Total number of not found sequences'):
            totnotnumber = int(line.strip().split('\t')[1])
            wrknumberseq = totnumber - totnotnumber
        elif line.startswith('Query:'):
            phyloblock = line.strip().split()[1]
            for line in wrkfile:
                if line.startswith('//'):
                    break
                elif line.startswith('>'):
                    globmin = 100
                    globmax = 0
                    gap = 'no'
                    organism = line.replace('>','').replace('\n','').replace('\r','').replace('(','').replace(')','').strip().split()[0]
                    minevalue = ['phyloblock', 100]
                    maxlength = ['phyloblock', 0]
                    if organism in wrkdatabase_2:
                        del wrkdatabase_2[organism]
                    else:
                        continue
                    for line in wrkfile:
                        if line.startswith('\n'):
                            if minevalue[0] == maxlength[0]:
                                preproc = gapsposition(minevalue[0][0] + '/' + minevalue[0][0], minevalue, [])
                                if len(preproc['insertions']) == 0:
                                    length = len(preproc['preprocessedseq'])
                                else:
                                    length = len(preproc['preprocessedseq']) - len(preproc['insertions'])
                                output.writelines(
                                    '>' + organism + '\n' + 'phyloblock\tstart\tend\tlength\tsequence\tinsertion\te-value' + '\n' + minevalue[0][0] + '\t' + minevalue[0][6] + '\t' +
                                    minevalue[0][7] + '\t' + str(length) + '\t' + preproc['preprocessedseq'] + '\t' + str(preproc[
                                        'insertions']) + '\t' + maxlength[0][2]
                                    + '\n')
                                #insertions = preproc['insertions']
                                if len(preproc['insertions']) > 0:
                                    for ins in preproc['insertions']:
                                        if ins in insertions:
                                            pass
                                        else:
                                            length = len(preproc['preprocessedseq'])
                                            insertions.append(ins)
                                            insertioninfo.append(
                                                '>' + organism + '\n' + 'phyloblock\tstart\tend\tlength\tsequence\tinsertion\te-value' + '\n' +
                                                str(maxlength[0][0]) + '\t' + str(maxlength[0][6]) + '\t' +
                                                str(maxlength[0][7]) + '\t' + str(length) + '\t' + preproc['preprocessedseq'] + '\t' + str(
                                                    preproc['insertions']) + '\t' + str(maxlength[0][2]) + '\n'
                                            )
                                break
                            else:
                                diflength = 'yes'
                                if minevalue[0][3] == maxlength[0][3]:
                                    diflength = 'no'
                                if int(minevalue[0][4])-int(maxlength[0][4]) == int(minevalue[0][6])-int(maxlength[0][6]):
                                    #use maxlength
                                    preproc = gapsposition(maxlength[0][0] + '/' + maxlength[0][0], maxlength, [])
                                    if len(preproc['insertions']) == 0:
                                        length = len(preproc['preprocessedseq'])
                                    else:
                                        length = len(preproc['preprocessedseq']) - len(preproc['insertions'])
                                    output.writelines(
                                        '>' + organism + '\n' + 'phyloblock\tstart\tend\tlength\tsequence\tinsertion\te-value' + '\n' + maxlength[0][0] + '\t' + maxlength[0][6] + '\t' +
                                        maxlength[0][7] + '\t' + str(length) + '\t' + preproc['preprocessedseq'] + '\t' + str(preproc['insertions']) + '\t' + maxlength[0][2] + '\n')
                                    #insertions = preproc['insertions']
                                    if len(preproc['insertions']) > 0:
                                        for ins in preproc['insertions']:
                                            if ins in insertions:
                                                pass
                                            else:
                                                length = len(preproc['preprocessedseq'])
                                                insertions.append(ins)
                                                insertioninfo.append(
                                                    '>' + organism + '\n' + 'phyloblock\tstart\tend\tlength\tsequence\tinsertion\te-value' + '\n' +
                                                    str(maxlength[0][0]) + '\t' + str(maxlength[0][6]) + '\t' +
                                                    str(maxlength[0][7]) + '\t' + str(length) + '\t' + preproc['preprocessedseq'] + '\t' + str(
                                                        preproc['insertions']) + '\t' + str(maxlength[0][2]) + '\n'
                                                    )
                                    break
                                else:
                                    #use e-value
                                    preproc = gapsposition(minevalue[0][0] + '/' + minevalue[0][0], minevalue, [])
                                    if len(preproc['insertions']) == 0:
                                        length = len(preproc['preprocessedseq'])
                                    else:
                                        length = len(preproc['preprocessedseq']) - len(preproc['insertions'])
                                    output.writelines(
                                        '>' + organism + '\n' + 'phyloblock\tstart\tend\tlength\tsequence\tinsertion\te-value' + '\n' + minevalue[0][0] + '\t' + minevalue[0][6] + '\t' +
                                        minevalue[0][7] + '\t' + str(length) + '\t' + preproc['preprocessedseq'] + '\t' + str(preproc['insertions']) + '\t' + maxlength[0][2]
                                        + '\n')
                                    #insertions = preproc['insertions']
                                    if len(preproc['insertions']) > 0:
                                        for ins in preproc['insertions']:
                                            if ins in insertions:
                                                pass
                                            else:
                                                length = len(preproc['preprocessedseq'])
                                                insertions.append(ins)
                                                insertioninfo.append(
                                                    '>' + organism + '\n' + 'phyloblock\tstart\tend\tlength\tsequence\tinsertion\te-value' + '\n' +
                                                    str(minevalue[0][0]) + '\t' + str(minevalue[0][6]) + '\t' +
                                                    str(minevalue[0][7]) + '\t' + str(length) + '\t' + preproc['preprocessedseq'] + '\t' + str(
                                                        preproc['insertions']) + '\t' + str(minevalue[0][2]) + '\n'
                                                )
                                    break
                        elif line.startswith('\t'): #WORK WITH MINEVALUE AND MAXLENGTH
                            if line.startswith('\tname'):
                                pass
                            else:
                                wrk_phyloblock = line.strip().split()
                                hmmlength = (int(wrk_phyloblock[5])-int(wrk_phyloblock[4]))
                                subseqlength = (int(wrk_phyloblock[7])-int(wrk_phyloblock[6]))
                                locmin = wrk_phyloblock[2]
                                locmin.replace('e-','*10**-')
                                locmin = math.log10(float(locmin))
                                if wrk_phyloblock[9] == 'NAN':
                                    if gap == 'yes':
                                        minevalue[1] = locmin
                                        minevalue[0] = wrk_phyloblock
                                        maxlength[1] = subseqlength
                                        maxlength[0] = wrk_phyloblock
                                        gap = 'no'
                                    if locmin < minevalue[1]:
                                        minevalue[1] = locmin
                                        minevalue[0] = wrk_phyloblock
                                        if maxlength[1] <= subseqlength:
                                            maxlength[1] = subseqlength
                                            maxlength[0] = wrk_phyloblock
                                    if maxlength[1] < subseqlength:
                                        maxlength[1] = subseqlength
                                        maxlength[0] = wrk_phyloblock
                                        if locmin == minevalue[1]:
                                            minevalue[1] = locmin
                                            minevalue[0] = wrk_phyloblock
                                else:
                                    if minevalue != ['phyloblock', 100]:
                                        if gap == 'no':
                                            pass
                                        else:
                                            if locmin < minevalue[1]:
                                                minevalue[1] = locmin
                                                minevalue[0] = wrk_phyloblock
                                                if maxlength[1] <= subseqlength:
                                                    maxlength[1] = subseqlength
                                                    maxlength[0] = wrk_phyloblock
                                            if maxlength[1] < subseqlength:
                                                maxlength[1] = subseqlength
                                                maxlength[0] = wrk_phyloblock
                                                if locmin == minevalue[1]:
                                                    minevalue[1] = locmin
                                                    minevalue[0] = wrk_phyloblock
                                    else:
                                        gap = 'yes'
                                        minevalue[1] = locmin
                                        minevalue[0] = wrk_phyloblock
                                        maxlength[1] = subseqlength
                                        maxlength[0] = wrk_phyloblock

    wrkfile.close()
    output.close()
    if len(insertions) > 0:
        print ('insertions! = '+str(insertions))
    output = open('insertions_preprocessed','w')
    output.writelines('\n---------------------------------------------\n')
    output.writelines('Found insertions:\n')
    for i in insertioninfo:
        output.writelines(i)
    output.close()
    os.chdir(back)
    if 'preproc' in locals():
        block_lengths.append(len(preproc['preprocessedseq'])-len(preproc['insertions']))
        print preproc
    else:
        block_lengths.append(0)
def joinseq(blocks, filename, path):
    joinseqdatabase = {}
    dbase = filename + '.711genomes.fasta'
    gdatabase = filename + '/' + dbase
    wrkdatabase = getlistofseq(gdatabase)
    wrkdatabase_2 = dict(wrkdatabase)
    for i in range(len(blocks)):
        block = blocks[i]
        back = ''
        # pr1.crdir(filename+'_test_1/blocks_output/blocks_for_phylogeny/'+block)
        os.chdir(path + block + '/')
        timebackagain = (path + block + '/').strip().split('/')
        timeback = ''
        for times in range(len(timebackagain) - 1):
            if (timebackagain[times] == '..'):
                pass
            else:
                timeback += '../'
        back += '../../../../'
        wrkfile = open('all_seq_preprocessed', 'r')
        #dbase = filename + '.711genomes.fasta'
        #gdatabase = back + filename + '/' + dbase
        #wrkdatabase = getlistofseq(gdatabase)
        #wrkdatabase_2 = dict(wrkdatabase)
        for line in wrkfile:
            if line.startswith('>'):
                organism = line.replace('>','').replace('\n','')
            elif line.startswith('phyloblock_'):
                if organism in wrkdatabase_2:
                    del wrkdatabase_2[organism]
                    joinseqdatabase[organism] = []
                    joinseqdatabase[organism].append([block]+line.replace('\n','').strip().split())
                else:
                    if organism in joinseqdatabase:
                        joinseqdatabase[organism].append([block]+line.replace('\n', '').strip().split())
                    else:
                        'error; organism not in database'
        wrkfile.close()
        os.chdir(back)
    return{'database':joinseqdatabase}
def addalign(filename, number_of_blocks):
    blocks = []
    block_lengths = []
    #filename = 'COG3425'
    for i in range(number_of_blocks):
        print ('seqpreprocess of BLOCK_'+str(i))
        seqpreprocess('BLOCK_'+str(i),filename,filename+'_test_1/blocks_output/blocks_for_phylogeny/', block_lengths)
        blocks.append('BLOCK_'+str(i))
    aaa = joinseq(blocks, filename, filename+'_test_1/blocks_output/blocks_for_phylogeny/')
    seqs = []
    for i in aaa['database']:
        seqs.append([i, aaa['database'][i]])
    seqs.sort(key = lambda x: len(x[1]))
    seqs = seqs[::-1]
    ambiguous_seqs = []
    work_seqs = []
    maxgap = [0 for i in range(number_of_blocks)]
    alignmentgaps = open(filename+'_test_1/blocks_output/blocks_output_blockdist','r')
    for line in alignmentgaps:
        aligngaps = line.strip().split()
        for i in range(len(aligngaps)):
            aligngaps[i] = aligngaps[i].replace('\'','').strip().split(':')
        break
    alignmentgaps.close()
    alignoldgap = []
    alignoldgap.append([int(aligngaps[0][0]),int(aligngaps[0][1])])
    maxgap[0] = int(aligngaps[0][0])
    for algap in range(len(aligngaps)-1):
        maxgap[algap+1] = int(aligngaps[algap+1][0]) - int(aligngaps[algap][1])
        print 'maxgap[algap+1] = '+str(maxgap[algap+1])
        alignoldgap.append([int(aligngaps[algap+1][0]), int(aligngaps[algap+1][1])])
    lostblocks = {}
    for sequence in seqs:
        block_start = 0
        block_end = 0
        blocklength = [[0,0] for i in range(number_of_blocks)]
        for block in sequence[1]:
            if block_start == 0:
                block_start = int(block[2])
                block_end = int(block[3])
                i = int(block[0].replace('BLOCK_', ''))
                blocklength[i] = [block_start-1,block_end-1]
            else:
                if block_start < int(block[2]):
                    if block_end < int(block[3]):
                        block_start = int(block[2])
                        block_end = int(block[3])
                        i = int(block[0].replace('BLOCK_', ''))
                        blocklength[i] = [block_start-1, block_end-1]
                    else:
                        ambiguous_seqs.append(sequence)
                        break
                else:
                    ambiguous_seqs.append(sequence)
                    break
        work_seqs.append(sequence)
        block_start = 0
        block_end = 0
        blocknull = 0
        for i in range(len(blocklength)):
            if blocklength[i][0] != blocklength[i][1] != 0:
                distance = blocklength[i][0] - block_end
                if distance > maxgap[i]:
                    if blocknull == 0:
                        maxgap[i]=distance
                    else:
                        maxgapsum = 0
                        for m in range(blocknull):
                            maxgapsum += maxgap[i-m-1]-block_lengths[i-m-1]
                        blocknull = 0
                        if distance > maxgapsum + maxgap[i]:
                            maxgap[i] = distance - maxgapsum
                else:
                    blocknull = 0
                block_start = blocklength[i][0]
                block_end = blocklength[i][1]
            else:
                if sequence[0] in lostblocks:
                    pass
                else:
                    lostblocks[sequence[0]] = []
                blocknull += 1
                continue
    print(os.getcwd())
    print 'maxgap = '+str(maxgap)

    oldalignment = getlistofseq(filename+'_test_1/'+filename+'_output.aln_1')
    organisms = []
    tempwrk = open(filename+'_test_1/'+filename+'_output.aln_1','r')
    for line in tempwrk:
        if line.startswith('>'):
            organisms.append(line.replace('>','').replace('\n','').replace('\r','').replace('(','').replace(')',''))
    tempwrk.close()
    alignoldgap = alignoldgap[::-1]
    maxgap = maxgap[::-1]
    output = open(filename+'_test_1/blocks_output/'+filename+'_add_align','w')
    wrkdatabase = filename+'/'+filename+'.711genomes.fasta'
    wrkdb = getlistofseq(wrkdatabase)
    for l in range(len(organisms)):
        newblock = oldalignment[organisms[l]]
        for i in range(len(alignoldgap)):
            if i == len(alignoldgap) - 1:
                locdist = alignoldgap[i][0]
            else:
                locdist = alignoldgap[i][0] - alignoldgap[i + 1][1]
            dif = maxgap[i] - locdist
            newblock = newblock[:alignoldgap[i][0]] + '-'*dif + newblock[alignoldgap[i][0]:]
        output.writelines('>'+organisms[l]+'\n'+newblock+'\n\r\n')
    block_lengths = block_lengths[::-1]
    for sequence in seqs:
        if sequence in ambiguous_seqs:
            continue
        gapped = 0
        seqname = sequence[0]
        if seqname in lostblocks:
            gapped = 1
        newblock = wrkdb[seqname]
        for i in range(len(newblock)):
            newblock = len(newblock)*'-'
        seqblocks = sequence[1]
        seqblocks = seqblocks[::-1]
        if len(seqblocks) == len(maxgap):
            for i in range(len(seqblocks)):
                countl = int(seqblocks[i][0].replace('BLOCK_',''))
                if i == len(seqblocks)-1:
                    locdist = int(seqblocks[i][2])-1
                else:
                    locdist = int(seqblocks[i][2]) - int(seqblocks[i+1][3]) - 1
                dif = maxgap[i] - locdist
                #print newblock[int(seqblocks[i][2])-1:int(seqblocks[i][3])]
                newblock = newblock[:int(seqblocks[i][2])-1] + '-' * dif + seqblocks[i][5] + newblock[int(seqblocks[i][3]):]
            output.writelines('>new|' + seqname + '\n' + newblock + '\n\r\n')
        else: #not full blocks
            length = len(newblock)
            end = 0
            wrkbl = len(maxgap)-1
            for i in range(len(seqblocks)):
                dif = 0
                dif2 = 0
                countl = int(seqblocks[i][0].replace('BLOCK_','')) #real block
                if i == len(seqblocks)-1:
                    end = 1
                else:
                    nextl = int(seqblocks[i+1][0].replace('BLOCK_',''))
                iti = len(maxgap)-countl-1 #
                itii = 0 #gapps
                itiii = 0 #blocks
                if i == 0: #i = 0 first block
                    if countl != len(maxgap)-1:
                        maxgapsum = 0
                        test = []
                        for l in range(iti): #0, 1 maxgap[2-0-1]=1 [2-1-1]=0
                            maxgapsum += maxgap[iti-l-1]
                            #print maxgap
                            #print maxgap[iti-l-1]
                            test.append(maxgapsum)
                            itii += 1
                            if length < int(seqblocks[i][3])+maxgapsum:
                                break
                        m = countl + itii
                        for l in range(itii): #2 times
                            if itii > itiii:
                                uselength = maxgap[iti-itii+l]
                            else:
                                uselength = 0
                            newblock = newblock[:int(seqblocks[i][3]) + maxgapsum - 1] + '-' * block_lengths[iti-itii+l] + newblock[
                                                                                        int(seqblocks[i][3]) + maxgapsum - 1:]
                            #itiii -= 1
                            maxgapsum -= maxgap[iti-itii+l]
                            test.append(maxgapsum)
                            #print newblock
                        #print test
                        #newblock = newblock[:int(seqblocks[i][2])]+seqblocks[i][5]+newblock[int(seqblocks[i][3]):]
                if end == 1:
                    if countl == 0:
                        locdist = int(seqblocks[i][2])-1
                        dif = maxgap[len(maxgap)-1]-locdist
                        #print ('real seq: ' + newblock[int(seqblocks[i][2]) - 1:int(seqblocks[i][3])])
                        #print ('align seq: ' + seqblocks[i][5])
                        newblock = newblock[:int(seqblocks[i][2]) - 1] + '-' * dif + seqblocks[i][5] + newblock[int(
                            seqblocks[i][3]):]
                    else:

                        loclength = int(seqblocks[i][2])-1
                        maxgapsum = 0
                        r = len(maxgap) - countl -1
                        #print newblock[int(seqblocks[i][2]) - 1:int(seqblocks[i][3])] + '\n'
                        newblock = newblock[:int(seqblocks[i][2])-1] + seqblocks[i][5] + (newblock[int(seqblocks[i][3]):])
                        #print newblock[int(seqblocks[i][2])-1:int(seqblocks[i][3])+5]
                        if loclength - maxgap[r] >= 0:
                            loclength -= maxgap[r]
                            maxgapsum += maxgap[r]
                        else:
                            dif2 = maxgap[r] - loclength
                            maxgapsum += maxgap[r] - loclength
                            for l in range(countl):
                                maxgapsum += maxgap[r + l + 1] + block_lengths[r + l + 1]
                            newblock = newblock[:int(seqblocks[i][2]) - 1 - loclength] + '-' * (
                                maxgapsum) \
                                       + newblock[int(seqblocks[i][2]) - 1 - loclength:]
                            break
                        for l in range(countl):
                            if loclength - maxgap[r + l + 1] >= 0: # not checked
                                loclength -= maxgap[r + l + 1]
                                newblock = newblock[:int(seqblocks[i][2]) - 1 - maxgapsum] + '-' * block_lengths[
                                    r + l + 1] + newblock[int(seqblocks[i][2]) - 1 - maxgapsum:]
                                maxgapsum += maxgap[r + l + 1]
                            else:
                                dif2 += maxgap[r + l + 1] - loclength # checked..
                                newblock = newblock[:int(seqblocks[i][2]) - 1 - maxgapsum] + '-' * (
                                dif2 + block_lengths[r + l + 1]) \
                                           + newblock[int(seqblocks[i][2]) - 1 - maxgapsum:]
                                maxgapsum += maxgap[r + l + 1] - dif2
                                loclength = 0
                                dif2 = 0
                        #newblock = '-'*dif2 + newblock
                else:
                    if countl == nextl + 1:
                        r = len(maxgap) - countl - 1
                        locdist = int(seqblocks[i][2]) - int(seqblocks[i+1][3]) - 1
                        dif = maxgap[r]-locdist
                        newblock = newblock[:int(seqblocks[i][2]) - 1] + '-' * dif + seqblocks[i][5] + newblock[int(
                            seqblocks[i][3]):]
                    else:
                        maxgapsum = 0
                        r = len(maxgap) - countl - 1
                        loclength = int(seqblocks[i][2]) - int(seqblocks[i+1][3]) - 1
                        newblock = newblock[:int(seqblocks[i][2])- 1] + seqblocks[i][5]+newblock[int(seqblocks[i][3]):]
                        if loclength - maxgap[r] >= 0:
                            loclength -= maxgap[r]
                            maxgapsum += maxgap[r]
                        else:
                            dif2 = maxgap[r]-loclength
                            maxgapsum += maxgap[r] - dif2
                            loclength = 0
                        for l in range(countl-nextl-1):
                            if loclength - maxgap[r+l+1] >= 0:
                                loclength -= maxgap[r+l+1]
                                newblock = newblock[:int(seqblocks[i][2]) - 1 - maxgapsum] + '-' * block_lengths[
                                    r + l + 1] + newblock[int(seqblocks[i][2]) - 1 - maxgapsum:]
                                maxgapsum += maxgap[r + l + 1]
                            else:
                                dif2 += maxgap[r + l + 1] - loclength
                                newblock = newblock[:int(seqblocks[i][2]) - 1 - maxgapsum - loclength] + '-' * (dif2+block_lengths[r+l+1]) \
                                           + newblock[int(seqblocks[i][2]) - 1 - maxgapsum - loclength:]
                                maxgapsum += maxgap[r + l + 1] - dif2
                                loclength = 0
                                dif2 = 0

                                ''''''
            output.writelines('>new_1|' + seqname + '\n' + newblock + '\n\r\n')
    output.close()
