import os
import re
import ch_scripts as pr1
import subprocess
import ch_func_2 as pr2
import sys
import time

# Only functions
# Here you can find functions to getlistofseq from path in dict format
# And you can get files with profiles from one block
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#
#to get groups of phylogenetic relatives

def getlistofseq(path):
    inp = open(path, 'r')
    output = {}
    for line in inp:
        if line.startswith('>'):
            seqname = line.replace('>','').replace('\n','').replace('\r','').replace('(','').replace(')','')
        elif line.startswith('\r\n'):
            pass
        else:
            sequence = line.replace('\r','').replace('\n','')
            output[seqname] = sequence
    inp.close()
    return output

def phylowork(block, filename, path, thhld, back):
    #pr1.crdir(filename+'_test_1/blocks_output/blocks_for_phylogeny/'+block)
    os.chdir(path+block+'/')
    timebackagain = (path+block+'/').strip().split('/') #from os.chdir(path+block+'/') -> timeback -> ../ -> add to back (for genomes database)
    timeback = ''
    #print ('timebackagain = ' + str(len(timebackagain)))
    for times in range(len(timebackagain)-1):
        if (timebackagain[times] == '..'):
            pass
        else:
            timeback += '../'
    back += timeback
    wrkfile = open('phylotree_'+block+'_changed.txt','r')
    bropen = 0
    beclose = 0
    phylostack = []
    phylogroup = []
    phylogroupdet = []
    iti = 0
    phyloiti = -1
    endline = 0
    endline_1 = 0
    for line in wrkfile:
        if line.endswith('(\n'):
            bropen += 1
            iti = 0
        elif line.endswith(tuple([')\n', ';\n'])): #add
            if line.startswith(':'):
                if (len(phylostack) > 0):
                    aaa = phylostack.pop()
                    stackiti = 0
                    bbb = []
                    ph = 0
                    aaa1 = 0
                    while (aaa1 < len(aaa)):
                        while (ph < len(phylogroup)):
                            phylogroup[ph][1] += float(line.replace(':','').replace(')\n','').replace(');\n',''))
                            if (phylogroup[ph][1]+aaa[aaa1][1] <= thhld):
                                aaa[aaa1][0] += phylogroup[ph][0]
                                aaa[aaa1][1] = min(phylogroup[ph][1],aaa[aaa1][1])
                                phylogroup.remove(phylogroup[ph])
                            else:
                                ph += 1
                        if (stackiti == 0):
                            bbb.append(aaa[aaa1])
                            stackiti += 1
                        else:
                            #print ('bbb = ' + str(bbb))
                            ccc = []
                            #print ('line 45')
                            ccciti = 0
                            bbb1 = 0
                            bbbs = []
                            while (bbb1 < len(bbb)):
                                if (aaa[aaa1][1] + bbb[bbb1][1] <= thhld):
                                    bbbs.append(bbb1)
                                    bbb1 += 1
                                    if bbb1 == len(bbb):
                                        bbbs = bbbs[::-1]
                                        for g in bbbs:
                                            aaa[aaa1][0] += bbb[g][0]
                                            aaa[aaa1][1] = min(bbb[g][1], aaa[aaa1][1])
                                            bbb.remove(bbb[g])
                                        ccc += aaa[aaa1]
                                else:
                                    ccciti += 1
                                    bbb1 += 1
                                    if (ccciti == len(bbb)):
                                        ccc.append(aaa[aaa1])
                            if len(bbb) > 0:
                                bbb += ccc
                            else:
                                bbb += [ccc]
                        aaa1 += 1
                    for bbb1 in bbb:
                        phylogroup.append(bbb1)
                        #print 'bbb1 = '+str(bbb1)
            else:
                up = line.strip().split(':')
                aaa2 = [[up[0]], float(up[1].replace(')', '').replace('\n', ''))]
                if (len(phylostack) > 0):
                    aaa1 = phylostack.pop()
                    if (aaa1[0][1] + aaa2[1] > thhld):
                        phylogroup.append([aaa1[0][0], aaa1[0][1]])
                        phylogroup.append([aaa2[0], aaa2[1]])
                        phyloiti += 2
                    else:
                        phylogroup.append([aaa1[0][0] + aaa2[0], min(aaa1[0][1], aaa2[1])])
                        phyloiti += 1
                else:
                    phylogroup.append([aaa2[0],aaa2[1]])
        elif line.endswith(',\n'): #stack
            if line.startswith(':'):
                ph = 0
                stackaaa = []
                endline_1 += 1
                while ph < len(phylogroup):
                    phylogroup[ph][1] += float(line.replace(':', '').replace(',\n', ''))
                    if (phylogroup[ph][1] > thhld):
                        phylogroupdet.append(phylogroup[ph])
                        phylogroup.remove(phylogroup[ph])
                    else:
                        stackaaa.append(phylogroup[ph])
                        phylogroup.remove(phylogroup[ph])
                if (len(stackaaa) > 0):
                    phylostack.append(stackaaa)
            else:
                up = line.strip().split(':')
                phylostack.append([[[up[0]], float(up[1].replace(',','').replace('\n',''))]])
                #[[],length]
        else:
            print line
    wrkfile.close()
    iti = 0
    blockfile = open(block, 'r')
    seqs = []
    sum = 0
    for line in blockfile:
        if line.startswith('>'):
            aaa = line.replace('>', '').replace('\n', '')
        else:
            bbb = line.replace('\n', '')
            seqs.append([aaa, bbb])
    seqs.sort(key=lambda x: x[0])
    blockfile.close()
    for i in phylogroup:
        pr1.crdir('phyloblock_' + str(iti))
        outputfile = open('phyloblock_' + str(iti) + '/phyloblock_' + str(iti),'w')
        #print len(i[0])
        sum += len(i[0])
        outputfile.writelines('# STOCKHOLM 1.0\r\n')
        outputfile.writelines('#=GF ID phyloblock_' + str(iti) + '\r\n')
        for k in i[0]:
            for seq in seqs:
                if seq[0] == k:
                    outputfile.writelines('>'+seq[0] + '\t' +seq[1] + '\r\n')
                    break
        outputfile.writelines('//\r\n\r\n')
        iti += 1
        outputfile.close()
    phylogroup = []
    for i in phylogroupdet:
        pr1.crdir('phyloblock_' + str(iti))
        outputfile = open('phyloblock_' + str(iti) + '/phyloblock_' + str(iti), 'w')
        sum += len(i[0])
        outputfile.writelines('# STOCKHOLM 1.0\r\n')
        outputfile.writelines('#=GF ID phyloblock_' + str(iti) + '\r\n')
        for k in i[0]:
            for seq in seqs:
                if seq[0] == k:
                    outputfile.writelines('>'+seq[0] + '\t' +seq[1] + '\r\n')
                    break
        outputfile.writelines('//\r\n\r\n')
        iti += 1
        outputfile.close()
    phylogroupdet = []
    print 'testing_set'
    dbase = filename+'.711genomes.fasta'
    training_set = pr2.get_sequences(back + filename + '_test_1/' + filename + '_output.aln_1', 'training_set_sequences')
    profile = {}
    trset = []
    hmmtime = 0
    for i in range(iti):
        os.chdir('phyloblock_' + str(i) + '/')
        pr2.part_4_1_hmmer('phyloblock_' + str(i), 'phyloblock_' + str(i))
        pr2.part_4_hmmsearch('phyloblock_' + str(i) + '.hmm', '../training_set_sequences',
                             'hmmsearch_training_set_' + str(i) + '.txt',
                             '--incE 2.0 --nobias --F3 1e-4 --tblout aaa_test')
        pr2.part_5_searchblocksinhmm('phyloblock_' + str(i) + '_training_set_sequences',
                                     training_set['sequences_database'], 'hmmsearch_training_set_' + str(i) + '.txt')
        dictfile = open('phyloblock_' + str(i), 'r')
        pr2_phylo = {}
        for line in dictfile:
            if line.startswith('>'):
                dictio = line.replace('>', '').replace('', '').strip().split('\t')
                pr2_phylo.update({dictio[0]: dictio[1]})
        phyloblockfile = open('phyloblock_' + str(i) + '_training_set_sequences_all_blocks_in', 'r')
        outputanalyze = open('phyloblock_' + str(i) + '_training_set_sequences_all_blocks_in_analysis', 'w')
        outputanalyze.writelines('sequences found in profile and in training set:\n')
        notinprofile = []
        dictfile.close()
        for line in phyloblockfile:
            if line.startswith('>> '):
                phseq = line.replace('>> ', '').replace('\n', '').replace('(', '').replace(')', '')
                if phseq in pr2_phylo:
                    outputanalyze.writelines(phseq + '\t' + pr2_phylo[phseq] + '\n')
                    del pr2_phylo[phseq]
                else:
                    notinprofile.append(phseq)
        phyloblockfile.close()
        outputanalyze.writelines('\nsequences found in profile but not in training set (FN):\n')
        for k in pr2_phylo:
            outputanalyze.writelines(k + '\t' + pr2_phylo[k] + '\n')
        outputanalyze.writelines('\nsequences found in training set but not in profile (FP):\n')
        for k in notinprofile:
            outputanalyze.writelines(k + '\n')
        outputanalyze.close()
        profile.update(pr2_phylo)
        for l in notinprofile:
            if l in trset:
                pass
            else:
                trset.append(l)
        os.chdir('../')
    hmmtime+= 1
    trset.sort()
    allseqanalysis = open('all_training_set_seqanalysis', 'w')
    allseqanalysis.writelines('Sequences that were found by another profile:\n')
    notfound = []
    for i in profile:
        if i in trset:
            allseqanalysis.writelines('>' + i + '\n')
            trset.remove(i)
        else:
            notfound.append(i)
    allseqanalysis.writelines('\nNumber of not found sequences = ' + str(len(notfound)) + '\n')
    allseqanalysis.writelines('\nSequences that were not found:\n')
    for i in notfound:
        allseqanalysis.writelines('>' + i + '\t' + profile[i] + '\n\n')
    allseqanalysis.writelines('\nNumber of sequences that were found more than one time = ' + str(len(trset)) + '\n')
    allseqanalysis.writelines('\nSequences that were found more than one time:\n')
    for i in trset:
        allseqanalysis.writelines('>' + i + '\n')

    print 'all sequences'
    #ALL SEQUENCES
    allseqanalysis.close()
    phyloblocks = {}
    gdatabase = back + filename + '/' + dbase
    wrkdatabase = getlistofseq(gdatabase)
    wrkdatabase_2 = dict(wrkdatabase)
    allblocks = [[] for m in range(iti)]
    time.sleep(2)
    for i in range(iti):
        time.sleep(0.05)
        os.chdir('phyloblock_' + str(i)+'/')
        if hmmtime == 0:
            pr2.part_4_1_hmmer('phyloblock_'+str(i), 'phyloblock_'+str(i))
        pr2.part_4_hmmsearch('phyloblock_'+str(i)+'.hmm', '../'+gdatabase, 'hmmsearch_phyloblock_' + str(i) + '.txt', '--incE 2.0 --nobias --F3 1e-4 --tblout aaa_test')
        part_4 = pr2.part_4_2_genomes_database('../'+gdatabase)
        pr2.part_5_searchblocksinhmm('phyloblock_'+str(i), part_4['part_4_database'], 'hmmsearch_phyloblock_' + str(i) + '.txt')
        phyloblockfile = open('phyloblock_' + str(i) + '_all_blocks_in', 'r')
        #
        # ALL SEQUENCES
        for line in phyloblockfile:
            if line.startswith('>> '):
                phseq = line.replace('>> ', '').replace('\n', '').replace('(', '').replace(')', '')
                if phseq in wrkdatabase:
                    allblocks[i].append(phseq)
                    for line in phyloblockfile:
                        if line.startswith('//'):
                            break
                        elif line.startswith('phyloblock'):
                            lphseq = line.strip().split('\t')
                            if phseq in phyloblocks:
                                phyloblocks[phseq].append(lphseq)
                            else:
                                phyloblocks[phseq] = []
                                phyloblocks[phseq].append(lphseq)
                    #allblocks[i].append([phseq, wrkdatabase[phseq]])
                    #resultfile.writelines(phseq + '\t' + wrkdatabase[phseq] + '\n')
                    if phseq in wrkdatabase_2:
                        del wrkdatabase_2[phseq]
                    else:
                        pass
                else:
                    print ('error; sequence not found.')
                    print phseq
        phyloblockfile.close()
        os.chdir('../')
    print 'all sequences_2'
    moreseq = [[] for m in range(iti)]
    resultfile = open('all_seqanalysis', 'w')
    resultfile.writelines('# Total number of sequences=\t' + str(len(wrkdatabase)) + '\n')
    resultfile.writelines('# Total number of not found sequences=\t'+str(len(wrkdatabase_2))+'\n')
    resultfile.writelines('---------------------------------------------\n\n')
    for i in range(iti):
        kkk = []
        resultfile.writelines('Query: phyloblock_' + str(i) + '\n')
        resultfile.writelines('Number of sequences found by phyloblock_'+str(i)+' = '+str(len(allblocks[i]))+'\n')
        resultfile.writelines('Sequences found by phyloblock_' + str(i) + ' only:\n\n')
        for k in allblocks[i]:
            k_iti = 0
            lphyloblock = 'phyloblocks: '+str(i)
            for l in range(iti):
                if k in allblocks[l]:
                    if l == i:
                        if (k_iti == 0):
                            kkk.append(k)
                            #print ('line_285'+str(k))
                            #resultfile.writelines('>' + k[0] + '\n' + k[1] + '\n')
                    else:
                        lphyloblock += ' '+str(l)
                        k_iti += 1
                        if k in kkk:
                            kkk.remove(k)
            if (lphyloblock != 'phyloblocks: ' + str(i)):
                moreseq[i].append([k, lphyloblock])
        for k in kkk:
            resultfile.writelines('>' + k + '\n' + '\tname\t! or ?\ti-Evalue\thmmlength\thmmstart\thmmend\tseqstart\tseqend\tsequence\thmmgaps\tseqgaps\n')
            for phbl in phyloblocks[k]:
                resultfile.writelines('\t'+'\t'.join(phbl) + '\n')
            resultfile.writelines(wrkdatabase[k]+'\n\n')
        resultfile.writelines('Number of sequences found by phyloblock_' + str(i) + ' and other phyloblocks = '+str(len(moreseq[i]))+'\n')
        resultfile.writelines('Sequences found by phyloblock_' + str(i) + ' and other phyloblocks:\n\n')
        for mseq in moreseq[i]:
            resultfile.writelines('>' + mseq[0] + '\t' + mseq[1] + '\n')
            resultfile.writelines('\tname\t! or ?\ti-Evalue\thmmlength\thmmstart\thmmend\tseqstart\tseqend\tsequence\thmmgaps\tseqgaps\n')
            for phbl in phyloblocks[mseq[0]]:
                resultfile.writelines('\t' + '\t'.join(phbl) + '\n')
            resultfile.writelines(wrkdatabase[mseq[0]] + '\n\n')
        resultfile.writelines('//\n\n')
    resultfile.writelines('Sequences that were not found:\n')
    for k in wrkdatabase_2:
        resultfile.writelines('>' + k+'\n'+wrkdatabase_2[k]+'\n\n')
    resultfile.close()
    os.chdir(timeback)