import os
import re
import ch_scripts as pr1 #crdir
import subprocess
import ch_func_2 as pr2change
import ch_phylo_2 as pr2phylo
import time

# compute phylogenetic tree...

def phylogenyget(path, filename, cog):
    if os.path.exists(path):
        os.chdir(path)
    else:
        print ('you haven\'t worked with this COG yet')
    fileblock = open(filename, 'r')
    pr1.crdir('blocks_for_phylogeny')
    os.chdir('blocks_for_phylogeny')
    #sumblock=[]
    i = 0
    for line in fileblock:
        if line.startswith('#=GF ID'):
            time.sleep(2)
            thld = 0.5
            block = line.strip().split()[2]
            pr1.crdir(block)
            wrkfile = open(block+'/'+block, 'w')
            iti = 0
            for line in fileblock:
                if line.startswith('//'):
                    wrkfile.close()
                    i += 1
                    break
                else:
                    seq = line.strip().split()
                    print seq
                    wrkfile.writelines(seq[0].replace('(','').replace(')','')+'\n'+seq[1]+'\n')
                iti += 1
            if len(seq[1]) < 10:
                thld = 0.1
            elif len(seq[1]) > 20:
                thld = 1
            elif len(seq[1]) > 15:
                thld = 0.75
            wrkfile.close()
            os.system('clustalw2 -infile=' + block + '/' + block + ' -TREE -OUTPUTTREE=ph -CLUSTERING=UPGMA')
            pr2change.changephyloformat(block + '/' + block+'.ph', block + '/phylotree_'+block+'_changed.txt')#pr2change
            pr2phylo.phylowork(block, cog, '', thld, '../../../') #===========================================================pr2phylo
    fileblock.close()
    pr1.crdir('sumblocks')
    os.chdir('../../../')